#!/opt/QtPalmtop/bin/ruby
#
# Simple IMAP Web mailer 'mongle_r/ja_JP'
#
# 'mongle' original written by geoff^sunheartcowfork.com
#     http://home.sunheartcowfork.com/mongle/
#           
# 2nd maintainer  Rero2@fumi. Kentarou KUNIKANE <rero2@yuumu.org>
#
# $Id: mongle_r.cgi,v 1.1.1.1 2003/04/12 10:57:20 rero2 Exp $
#

require 'net/imap'
require 'net/smtp'
require 'kconv'
require 'cgi'
require 'time'
require 'parsedate'

# ----- configuration
userConfig = 'YOURLOGINNAME'
passConfig = 'YOURPASSWORD'
imapServer = 'IMAPSERVER'
imapPort = '143'
baseUrl = 'http://localhost/mongle_r.cgi'
fromField = 'YOUR MAIL ADDRESS'
smtpServer = 'SMTPSERVER'
mailDomain = 'MACHINENAME'
imapDirectory = ''
sentFolder = nil
enableFolder = false
defaultNum = 4
Version = "0.2"

# - - - - - - - - - -
cgi = CGI.new
mailBox = cgi['mailbox'].to_s
if mailBox == '' 
  mailBox = 'INBOX'
end
uId = cgi['uid'][0].to_i
APage = cgi['page'][0].to_i
ANum = cgi['num'][0].to_i

imap = Net::IMAP.new(imapServer, imapPort)
imap.login(userConfig, passConfig)
imap.select(mailBox)
imap.examine(mailBox)

recent = imap.status(mailBox, ["RECENT"]).fetch("RECENT")
total = imap.status(mailBox, ["MESSAGES"]).fetch("MESSAGES")
if ANum == 0 then
  num = defaultNum
  ArgNum = ''
else
  num = ANum
  ArgNum = sprintf("&num=%d", num)
end
ArtFirst = total - num - (APage * (num + 1))
ArtEnd = total - (APage * (num + 1))
ArtFirst = 1 if ArtFirst < 1
ArtEnd = 1 if ArtEnd < 1
argPage = sprintf("&page=%d", APage)

# --------------------------------------------------------
# ---- html start
#print "HTTP/1.1 200 OK\r\n"
print "Content-Type: text/html\r\n\r\n"

print "<html><head><title>mongle_r/ja_JP | #{ cgi['do'] }</title>\n";
print "<meta http-equiv='Content-Type' CONTENT='text/html; charset=ISO-2022-JP'>\n</head>\n"
print "<font face=\"Arial,Helvetica,sans-serif\">\n";
print "<body bgcolor=\"#ffffff\"><h1>mongle_r/ja_JP | #{ cgi['do'] }</h1>"
print "</font>\n";

print "<pre>"
print "<b>imap:</b> (#{userConfig}@#{imapServer}:#{imapPort}) "
print imap.greeting[0]
print "\n"

# --------------------------------------------------------
# ----- mailbox list/menu
print '<b>imap.mailbox</b>.<a href="',baseUrl,'?do=list&mailbox=', imap.list("", "inbox")[0].name, argPage, ArgNum, '">', imap.list("", "inbox")[0].name, "</a>"
if "INBOX" == mailBox 
  print " (total.#{total} recent.#{recent})"
end 
print "\n"

if enableFolder == true then
  f = imap.list("", imapDirectory+"*")
  f.each { |i| 
  #  if i.attr.to_s.include?("NoInferiors")
    if !i.attr.to_s.include?(":Noselect")
      print '<b>imap.mailbox</b>.<a href="',baseUrl,'?do=list&mailbox=', i.name, argPage, ArgNum, '">', i.name, "</a>"
      if i.name == mailBox 
        print " (total.#{total} recent.#{recent})"  
      end 
    print "\n"
  end
  }
end

print "<b>imap</b>.<a href=\"",baseUrl,"?do=write&mailbox=", mailBox, argPage, ArgNum, "\">compose</a>\n"


# -------------------------------------------------
# ----- read or write or send
if cgi['do'].to_s == 'read'
	print "<hr>"
	print "<b>message</b>.", uId, "\n"
	print "<b>message</b>.<a href=\"',baseUrl,'?do=write&uid=", uId, "&mailbox=", mailBox, argPage, ArgNum, "\">reply</a>\n"
	print imap.uid_fetch(uId, "BODY[]")[0][1]["BODY[]"]
elsif cgi['do'].to_s == 'write'
	print "<hr>"
	if uId != 0
		toField = imap.uid_fetch(uId, "BODY[HEADER.FIELDS (FROM)]")[0].attr["BODY[HEADER.FIELDS (FROM)]"].gsub(/From:.*?<(.*)>/,'\1').gsub(/(\r|\n)/,'')
#		ccField = ''
		subjectField = imap.uid_fetch(uId, "BODY[HEADER.FIELDS (SUBJECT)]")[0].attr["BODY[HEADER.FIELDS (SUBJECT)]"].gsub(/Subject:\s+(.*)/,'\1').gsub(/(\r|\n)/,'').squeeze(" ")
		subjectField = "Re:" + subjectField
		bodyField = ''
		imap.uid_fetch(uId, "BODY[]")[0][1]["BODY[]"].each {|i| bodyField = bodyField + "> " + i}
		end
	print "<b>message</b>.", uId, "\n"
	print '<form method=post action="',baseUrl,'">'
	print '<input type=hidden name="do" value="send">'
	print "   from: <input type=text size=73 name=fromField value=\"#{ fromField }\">\n"
	print "     to: <input type=text size=73 name=toField value=\"#{ toField }\">\n"
	print "subject: <input type=text size=73 name=subjectField value=\"#{ subjectField }\">\n"
	print "   body: <textarea align=bottom name=bodyField wrap=off rows=20 cols=73>#{ bodyField }</textarea>\n"
#	print "     cc: <input type=text size=73 name=ccField value=\"#{ ccField }\">\n"
	print "   send: <input type=submit name=doIt value=\"Post\">\n"
	print "</form>"
elsif cgi['do'].to_s == 'send'
	print "<hr>"
	fromField = cgi['fromField'][0]
	toField = cgi['toField'][0]
        mailBody = cgi['bodyField'][0]
        sendDate = Time.now.rfc2822
        sendSubject = cgi['subjectField'][0].toeuc.gsub(/[-]\S*\s*/) {|x|
          x.scan(/.{1,10}/).map {|y|
            "=?iso-2022-jp?B?" + y.tojis.to_a.pack('m').chomp + "?="
          }.join("\n ")
        }
        message_id = Process.pid.to_s + "." + Time.now.to_i.to_s + "@" + smtpServer
        message = ''
        message << "Subject: #{ sendSubject }\r\n"
        message << "To: #{ toField }\r\n"
        message << "Date: #{ sendDate }\r\n"
        message << "Content-Type: text/plain; charset=iso-2022-jp\r\n"
        message << "Content-Transfer-Encoding: 7bit\r\n"
        message << "Message-Id: #{message_id}\r\n"
        message << "X-Mailer: mongle web mailer #{ Version }\r\n"
        message << "\r\n"
        message << mailBody.tojis
	smtp = Net::SMTP.new(smtpServer, 25)
	smtp.start(mailDomain)
	smtp.ready(fromField, toField ) { |a|
          a.write message
	}
	smtp.finish
        # - to sent
        imap.append(sentFolder, message) if sentFolder
	print "<b>message</b>.<font color=\"#00ff00\">sent</font>\n"
end


# -------------------------------------------------
# ----- Start the mailbox message list here
print "<hr>"
print "<b>#{ mailBox }</b>.list : "
print "[DispMax "
print '<a href="',baseUrl,'?do=list&mailbox=', imap.list("", "inbox")[0].name, argPage, '">', (defaultNum + 1), '</a>'
for loop in [10,15,20,25,30]
  argNumTmp = sprintf("&num=%d", loop-1)
  print '/<a href="',baseUrl,'?do=list&mailbox=', imap.list("", "inbox")[0].name, argPage, argNumTmp, '">', loop, '</a>'
end
print "]"

#print imap.fetch(total.downto(first), "UID")
ArtEnd.downto(ArtFirst) { |f| 
    data = imap.fetch(f, ["RFC822.SIZE", "INTERNALDATE", "UID"])[0]
    print "<dt>"
    outDate = ParseDate.parsedate( data.attr["INTERNALDATE"] )
    print "<i>", sprintf("%02d", outDate[3].to_s), ":", sprintf("%02d", outDate[4].to_s), ":", sprintf("%02d", outDate[5].to_s), "/", sprintf("%02d%02d ", outDate[1].to_s, outDate[2].to_s),"</i>"

    outFromAddress = imap.fetch(f, "ENVELOPE")[0].attr["ENVELOPE"].send(:from)
    outFrom = (outFromAddress[0].mailbox + "@" + outFromAddress[0].host)
    print outFrom.slice(0,19).ljust(20)
    
    outSubject = imap.fetch(f, "ENVELOPE")[0].attr["ENVELOPE"].send(:subject).tojis.gsub(/\r\n\s+/, "")

    if outSubject == ' '
	outSubject = '#'
	end
    if outSubject == ''
	outSubject = '#'
	end
    print '<a href="',baseUrl,'?do=write&mailbox=', mailBox,'&uid=', data.attr["UID"], argPage, ArgNum, '">R</a> '
    print '<a href="',baseUrl,'?do=read&mailbox=', mailBox,'&uid=', data.attr["UID"], argPage, ArgNum, '">', outSubject, '</a> '

    print "(", data.attr["RFC822.SIZE"], ") "
    print "\n"
    }

printf("\nPage%d : ", APage+1);
if (APage > 0) then
  APageTmp = APage - 1
  argPage = sprintf("&page=%d", APageTmp)
  print '<a href="',baseUrl,'?do=list&mailbox=', mailBox, argPage, ArgNum, '"> &lt;&lt;Previous</a> | '
end
if (ArtFirst > 1) then
  APageTmp = APage + 1
  argPage = sprintf("&page=%d", APageTmp)
  print '<a href="',baseUrl,'?do=list&mailbox=', mailBox, argPage, ArgNum, '"> Next&gt;&gt;</a>'
end

print "</pre></body></html>"

imap.close
